#include <stdio.h>
#include <string.h>
#include "CH57x_common.h"
#include "core_cm0.h"
#include "iic.h"
/**
gpioģiicߣ
https://blog.csdn.net/ctyqy2015301200079/article/details/83830326
*/

#define SCL1 GPIO_Pin_20
#define SDA1 GPIO_Pin_21
#define SCL0 GPIO_Pin_10
#define SDA0 GPIO_Pin_11

#define  io_input_B( pin ) GPIOB_ModeCfg( pin , GPIO_ModeIN_PU)//GPIO_ModeIN_Floating)
#define  io_output_B( pin ) GPIOB_ModeCfg( pin , GPIO_ModeOut_PP_5mA)
#define io_set_high_B( pin ) GPIOB_SetBits( pin )
#define io_set_low_B( pin ) GPIOB_ResetBits( pin )
#define io_get_B( pin ) GPIOB_ReadPortPin( pin )

#define  io_input_A( pin ) GPIOA_ModeCfg( pin , GPIO_ModeIN_PU)//GPIO_ModeIN_Floating)
#define  io_output_A( pin ) GPIOA_ModeCfg( pin , GPIO_ModeOut_PP_5mA)
#define io_set_high_A( pin ) GPIOA_SetBits( pin )
#define io_set_low_A( pin ) GPIOA_ResetBits( pin )
#define io_get_A( pin ) GPIOA_ReadPortPin( pin )
volatile unsigned char i2c0_busy=0;
void delay_us(uint16_t time)
{
    uint16_t i, j;
    for (i=0; i<4; i++)	
    {
        for (j=0; j<time; j++);
    }
}

void i2c_init(uint8_t port)
{
	//io_func_config(SDA, IO_FUNC_GPIO);	// choose IO_CONFIG_PB0 as GPIO
	//io_func_config(SCL, IO_FUNC_GPIO);	// choose IO_CONFIG_PB1 as GPIO
	if (port==1)
	{
		io_input_B(SDA1);		// SDA input
		io_input_B(SCL1);		// SCL input
	}else if(port==0)
	{
		io_input_A(SDA0);		// SDA input
		io_input_A(SCL0);		// SCL input
	}
	
	delay_us(20);
}


void i2c_start(uint8_t port)
{
		if (port==1)
	{
	io_output_B(SDA1);		// SDA output
	io_output_B(SCL1);		// SCL output
	io_set_high_B(SDA1);	// SDA=1
	io_set_high_B(SCL1);	// SCL=1
	delay_us(5);
	io_set_low_B(SDA1);	// SDA=0
	delay_us(5);
	}else if (port==0)
	{
		io_output_A(SDA0);		// SDA output
	io_output_A(SCL0);		// SCL output
	io_set_high_A(SDA0);	// SDA=1
	io_set_high_A(SCL0);	// SCL=1
	delay_us(5);
	io_set_low_A(SDA0);	// SDA=0
	delay_us(5);
	}
}

void i2c_stop(uint8_t port)
{
if (port==1)
	{	
	io_output_B(SDA1);		// set SDA as input
	io_output_B(SCL1);		// set SCL as input
	
	//if (io_get(SCL) == 1)
		io_set_low_B(SCL1);	// SDA=0
	//if (io_get(SDA) == 1)
		io_set_low_B(SDA1);	// SDA=0
	delay_us(5);
	io_set_high_B(SCL1);	// SCL=1
	delay_us(5);
	io_set_high_B(SDA1);	// SDA=1
	delay_us(5);
	// release SDA and SCL
	io_input_B(SDA1);		// set SDA as input
	//io_input(SCL);		// set SCL as input
	}else if (port==0)
	{
			io_output_A(SDA0);		// set SDA as input
	io_output_A(SCL0);		// set SCL as input
	
	//if (io_get(SCL) == 1)
		io_set_low_A(SCL0);	// SDA=0
	//if (io_get(SDA) == 1)
		io_set_low_A(SDA0);	// SDA=0
	delay_us(5);
	io_set_high_A(SCL0);	// SCL=1
	delay_us(5);
	io_set_high_A(SDA0);	// SDA=1
	delay_us(5);
	// release SDA and SCL
	io_input_A(SDA0);		// set SDA as input
	//io_input(SCL);		// set SCL as input
	}
}

uint8_t i2c_read_ack(uint8_t port)
{
	uint8_t ack;
if (port==1)
{
	io_input_B(SDA1);		// SDA input
	io_set_high_B(SCL1);	// SCL=1
	delay_us(5);	
	if( io_get_B(SDA1)) {ack=1; } else {ack=0;}
	
	io_set_low_B(SCL1);	// SCL=0

}else if (port==0)
{
	io_input_A(SDA0);		// SDA input
	io_set_high_A(SCL0);	// SCL=1
	delay_us(5);	
	if( io_get_A(SDA0)) {ack=1; } else {ack=0;}
	
	io_set_low_A(SCL0);	// SCL=0
}
	delay_us(5);
	return ack;
}


void i2c_send_ack(uint8_t port)
{
if (port==1)
{	
	io_output_B(SDA1);
	io_set_low_B(SCL1);	// SCL=0
	io_set_low_B(SDA1);	// SDA=0
	delay_us(5);
	io_set_high_B(SCL1);	// SCL=1
	delay_us(5);
	// TAKE CAREFULLYThese two orders below must be included
	// to pull down the SCL for the following opreations.
	io_set_low_B(SCL1);	// SCL=0

}else if (port==0)
{
		io_output_A(SDA0);
	io_set_low_A(SCL0);	// SCL=0
	io_set_low_A(SDA0);	// SDA=0
	delay_us(5);
	io_set_high_A(SCL0);	// SCL=1
	delay_us(5);
	// TAKE CAREFULLYThese two orders below must be included
	// to pull down the SCL for the following opreations.
	io_set_low_A(SCL0);	// SCL=0
}
	delay_us(5);
}

void i2c_send_nack(uint8_t port)
{
if (port==1)
{
	io_output_B(SDA1);
	io_set_low_B(SCL1);	// SCL=0
	io_set_high_B(SDA1);	// SDA=1
	delay_us(5);
	io_set_high_B(SCL1);	// SCL=1
	delay_us(5);
	io_set_low_B(SCL1);	// SCL=0
}else if (port==0)
{
	io_output_A(SDA0);
	io_set_low_A(SCL0);	// SCL=0
	io_set_high_A(SDA0);	// SDA=1
	delay_us(5);
	io_set_high_A(SCL0);	// SCL=1
	delay_us(5);
	io_set_low_A(SCL0);	// SCL=0	
}
	delay_us(5);
}

uint8_t i2c_ack_check(uint8_t port, uint8_t ctrl_byte)
{
if (port==1)
{
	i2c_start(1);
	i2c_write_single_byte(1,ctrl_byte);
	if(i2c_read_ack(1) == 0)
	{
		//sl_printf("i2c_read_ack() == 0.\n");
		// time delay here is not necessary, just to make waveforms more readable
		delay_us(30);
		//i2c_stop();
		io_input_B(SDA1);		// set SDA as input
		io_input_B(SCL1);		// set SCL as input
		return 0;
	}
	else
	{
		//sl_printf("i2c_read_ack() == 1.\n");
		// time delay here is to save computing resource
		delay_us(100);
		//io_input(SDA);		// set SDA as input
		//io_input(SCL);		// set SCL as input
		return 1;
	}
}else if(port==0)
{
		i2c_start(0);
	i2c_write_single_byte(0,ctrl_byte);
	if(i2c_read_ack(0) == 0)
	{
		//sl_printf("i2c_read_ack() == 0.\n");
		// time delay here is not necessary, just to make waveforms more readable
		delay_us(30);
		//i2c_stop();
		io_input_A(SDA0);		// set SDA as input
		io_input_A(SCL0);		// set SCL as input
		return 0;
	}
	else
	{
		//sl_printf("i2c_read_ack() == 1.\n");
		// time delay here is to save computing resource
		delay_us(100);
		//io_input(SDA);		// set SDA as input
		//io_input(SCL);		// set SCL as input
		return 1;
	}
}
return 0;
}


uint8_t i2c_read_single_byte(uint8_t port)
{
	uint8_t i=8;
	uint8_t i2c_buff = 0x0;
	// ÿreadʼǸߵƽʹMSB is low ҲҪȸٵ(SCL=0ڼһС͹)
	// Is that because of setting SDA as input, making it HIGH at the very beginning? Maybe so.
	delay_us(5);
if (port==1)
{	
	io_input_B(SDA1);				// SDA input
	delay_us(5);
	while (i--)
	{
		i2c_buff = i2c_buff<<1;
		io_set_high_B(SCL1);		// SCL=1
		delay_us(5);
		if(io_get_B(SDA1))
			i2c_buff |= 0x01;							// Write 1 to LSB of i2c_buff
		else
			i2c_buff &= 0xFE;							// Write 0 to LSB of i2c_buff
		delay_us(5);
		io_set_low_B(SCL1);		// SCL=0
		delay_us(5);
		//i2c_buff = i2c_buff<<1;						// move to the next MSB(from MSB to LEB)
	}
}else if (port==0)
{
	io_input_A(SDA0);				// SDA input
	delay_us(5);
	while (i--)
	{
		i2c_buff = i2c_buff<<1;
		io_set_high_A(SCL0);		// SCL=1
		delay_us(5);
		if(io_get_A(SDA0))
			i2c_buff |= 0x01;							// Write 1 to LSB of i2c_buff
		else
			i2c_buff &= 0xFE;							// Write 0 to LSB of i2c_buff
		delay_us(5);
		io_set_low_A(SCL0);		// SCL=0
		delay_us(5);
		//i2c_buff = i2c_buff<<1;						// move to the next MSB(from MSB to LEB)
	}	
}

	//sl_printf("i2cbuf=%d\n", i2c_buff);
	return i2c_buff;
}

void i2c_write_single_byte(uint8_t port, uint8_t i2c_buff)
{
	
	uint8_t i=8;
if (port==1)
{
	io_output_B(SDA1);		// SDA output
	io_output_B(SCL1);		// SCL output
	while (i--)
	{
		io_set_low_B(SCL1);			// SCL=0
		delay_us(5);
		if(i2c_buff & 0x80)					// MSB(i2c_buff)==1
			io_set_high_B(SDA1);		// SDA=1
		else
			io_set_low_B(SDA1);		// SDA=0
		io_set_high_B(SCL1);			// SCL=1
		delay_us(5);
		i2c_buff = i2c_buff<<1;							// move to the next MSB(from MSB to LEB)
	}
	// After transfer, release the SCL line
	io_set_low_B(SCL1);				// SCL=0

}else if (port==0)
{
	io_output_A(SDA0);		// SDA output
	io_output_A(SCL0);		// SCL output
	while (i--)
	{
		io_set_low_A(SCL0);			// SCL=0
		delay_us(5);
		if(i2c_buff & 0x80)					// MSB(i2c_buff)==1
			io_set_high_A(SDA0);		// SDA=1
		else
			io_set_low_A(SDA0);		// SDA=0
		io_set_high_A(SCL0);			// SCL=1
		delay_us(5);
		i2c_buff = i2c_buff<<1;							// move to the next MSB(from MSB to LEB)
	}
	// After transfer, release the SCL line
	io_set_low_A(SCL0);				// SCL=0

}
	delay_us(5);
}


uint8_t i2c_write_multi_byte(uint8_t port,uint8_t addr,uint8_t reg_width ,uint16_t reg_addr, uint8_t *buff,uint16_t len)
{
	//i2c_stop(port);
	i2c_start(port);
	i2c_write_single_byte(port,addr);
	if (i2c_read_ack(port))	//ackӦ˳
	{
		i2c_stop(port);
		return 1;
	}
	if (reg_width==16)	//16λĴַŷ͸8λ
	{
		i2c_write_single_byte(port,reg_addr>>8);	//͸8λ
		i2c_read_ack(port);
	}
	i2c_write_single_byte(port,reg_addr & 0x00ff);	//͵8λ
	i2c_read_ack(port);
	while(len--)
	{
		i2c_write_single_byte(port,*buff++);
		i2c_read_ack(port);
	}
	i2c_stop(port);
	return 0;
}

uint8_t i2c_read_multi_byte(uint8_t port,uint8_t addr,uint8_t reg_width ,uint16_t reg_addr, uint8_t *buff,uint16_t len)
{
	//i2c_stop(port);
	i2c_start(port);
	i2c_write_single_byte(port,addr);
	if (i2c_read_ack(port))	//ackӦ˳
	{
		i2c_stop(port);
		return 1;
	}
	if (reg_width==16)	//16λĴַŷ͸8λ
	{
		i2c_write_single_byte(port,reg_addr>>8);	//͸8λ
		i2c_read_ack(port);
	}
	i2c_write_single_byte(port,reg_addr & 0x00ff);	//͵8λ
	i2c_read_ack(port);
	mDelaymS(1);
	i2c_start(port);
	i2c_write_single_byte(port,addr|0x01);	//
	i2c_read_ack(port);
	while(len)
	{
		*buff = i2c_read_single_byte(port);
		if(1 == len)
		{
			i2c_send_nack(port);
		}
		else
		{
			i2c_send_ack(port);
		}
		buff++;
		len--;
	}
	i2c_stop(port);
	return 0;
}
