#ifndef __VIRTUAL_TIMER_H
#define __VIRTUAL_TIMER_H
#include <stdint.h>
#include <stddef.h>
#include "CH57x_common.h"
#include "CH57xBLE_LIB.H"
#include "stdint.h"

#ifdef __cplusplus
extern "C"
{
#endif

	
#define TIMER_TASK_TMOS_EVT_TEST_1   (0x0001<<0)
#define TIMER_TASK_TMOS_EVT_TEST_2   (0x0001<<1)
#define TIMER_TASK_TMOS_EVT_TEST_3   (0x0001<<2)
#define TIMER_TASK_TMOS_EVT_TEST_4   (0x0001<<3)
#define TIMER_TASK_TMOS_EVT_TEST_5   (0x0001<<4)



	
	
/*
0:DelayMS ӳٺ
1:SendStatus ʱ״̬
2: WiegandClearData
3: CheckReader
4: cmd_switch
*/
#define SOFT_TMR_COUNT	6		/* ʱĸ */
/* ȴʱʱڼ䣬CPUIDLE״̬ Ŀǰǿ */
#define CPU_IDLE()

/* ʱṹ壬Ա volatile, CŻʱ */
typedef struct
{
	volatile uint32_t reload;	/* ֵ */
	volatile uint32_t count;	/*  */
	volatile uint8_t flag;		/* ʱ־  */
	volatile uint8_t run;	//б־
	volatile void(*fun)(void);	//ʱڻص
	volatile uint8_t autorestart;  //ǷԶ¿ʼfunΪNULLʱЧ
	
}SOFT_TMR;

extern volatile SOFT_TMR g_Tmr[];
void InitVirtualTimer(void);
void DelayMS(uint32_t n);
void StartTimer(uint8_t _id, uint32_t _period, void(*fun),uint8_t autorestart);
uint8_t CheckTimer(uint8_t _id);
void PauseTimer(uint8_t _id);
void ResumeTimer(uint8_t _id);
uint8_t TimerIsRuning(uint8_t _id);
void SoftTimerDec(uint8_t _tmr);
void SoftTimerRun(void);

#ifdef __cplusplus
}
#endif
#endif
